from __future__ import annotations

from collections.abc import Mapping
from typing import Any, TypeVar

from attrs import define as _attrs_define
from attrs import field as _attrs_field

T = TypeVar("T", bound="ItemResponse")


@_attrs_define
class ItemResponse:
    """
    Example:
        {'id': 123456, 'barcode': 'RX12345678DE', 'product': 'GPT', 'serviceLevel': 'PRIORITY', 'custRef':
            'BRE-2021-XIT', 'recipient': 'Doris Bronson', 'recipientPhone': '+441234567890', 'recipientEmail':
            'doris@somewhere.non.eu', 'addressLine1': 'Uptown street 10', 'addressLine2': '2nd floor', 'city': 'London',
            'postalCode': 'SW1A 2AA', 'destinationCountry': 'GB', 'shipmentCurrency': 'EUR', 'shipmentGrossWeight': 1500,
            'senderTaxId': 'IOSS number', 'importerTaxId': 'IOSS number', 'returnItemWanted': False, 'shipmentNaturetype':
            'SALE_GOODS', 'contents': [{'contentPieceHsCode': 1234567890, 'contentPieceDescription': 'Hairspray',
            'contentPieceValue': '120.50', 'contentPieceNetweight': 1200, 'contentPieceOrigin': 'DE', 'contentPieceAmount':
            2}]}

    """

    additional_properties: dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> dict[str, Any]:
        field_dict: dict[str, Any] = {}
        field_dict.update(self.additional_properties)

        return field_dict

    @classmethod
    def from_dict(cls: type[T], src_dict: Mapping[str, Any]) -> T:
        d = dict(src_dict)
        item_response = cls()

        item_response.additional_properties = d
        return item_response

    @property
    def additional_keys(self) -> list[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
